--- old/usr/src/grub/grub-0.97/stage2/fsys_zfs.c	Tue Oct  1 14:04:17 2013
+++ new/usr/src/grub/grub-0.97/stage2/fsys_zfs.c	Tue Oct  1 14:04:17 2013
@@ -23,7 +23,7 @@
  */
 
 /*
- * Copyright (c) 2012 by Delphix. All rights reserved.
+ * Copyright (c) 2013 by Delphix. All rights reserved.
  * Copyright (c) 2013 by Saso Kiselkov. All rights reserved.
  */
 
@@ -966,6 +966,7 @@
  */
 static const char *spa_feature_names[] = {
 	"org.illumos:lz4_compress",
+	"com.delphix:extensible_dataset",
 	NULL
 };
 
@@ -1044,7 +1045,7 @@
 	    stack))
 		return (errnum);
 
-	if (errnum = dnode_get(mosmdn, objnum, DMU_OT_DSL_DIR, mdn, stack))
+	if (errnum = dnode_get(mosmdn, objnum, 0, mdn, stack))
 		return (errnum);
 
 	if (fsname == NULL) {
@@ -1086,7 +1087,7 @@
 		if (zap_lookup(mdn, cname, &objnum, stack))
 			return (ERR_FILESYSTEM_NOT_FOUND);
 
-		if (errnum = dnode_get(mosmdn, objnum, DMU_OT_DSL_DIR,
+		if (errnum = dnode_get(mosmdn, objnum, 0,
 		    mdn, stack))
 			return (errnum);
 
@@ -1099,7 +1100,7 @@
 		*obj = headobj;
 
 skip:
-	if (errnum = dnode_get(mosmdn, headobj, DMU_OT_DSL_DATASET, mdn, stack))
+	if (errnum = dnode_get(mosmdn, headobj, 0, mdn, stack))
 		return (errnum);
 	if (issnapshot) {
 		uint64_t snapobj;
@@ -1112,8 +1113,7 @@
 			return (errnum);
 		if (zap_lookup(mdn, snapname + 1, &headobj, stack))
 			return (ERR_FILESYSTEM_NOT_FOUND);
-		if (errnum = dnode_get(mosmdn, headobj,
-		    DMU_OT_DSL_DATASET, mdn, stack))
+		if (errnum = dnode_get(mosmdn, headobj, 0, mdn, stack))
 			return (errnum);
 		if (obj)
 			*obj = headobj;
